diff --git a/src/cpu/amd/Kconfig b/src/cpu/amd/Kconfig
index cec4916..2cd1761 100644
--- a/src/cpu/amd/Kconfig
+++ b/src/cpu/amd/Kconfig
@@ -1,8 +1,10 @@
 #source src/cpu/amd/socket_754/Kconfig
 #source src/cpu/amd/socket_939/Kconfig
 #source src/cpu/amd/socket_940/Kconfig
-#source src/cpu/amd/socket_AM2/Kconfig
+source src/cpu/amd/socket_AM2/Kconfig
 #source src/cpu/amd/socket_AM2r2/Kconfig
 source src/cpu/amd/socket_F/Kconfig
 #source src/cpu/amd/socket_F_1207/Kconfig
 #source src/cpu/amd/socket_S1G1/Kconfig
+
+source src/cpu/amd/model_fxx/Kconfig
diff --git a/src/cpu/amd/Makefile.inc b/src/cpu/amd/Makefile.inc
index c63bc2b..578de4f 100644
--- a/src/cpu/amd/Makefile.inc
+++ b/src/cpu/amd/Makefile.inc
@@ -1 +1,2 @@
 subdirs-$(CONFIG_CPU_AMD_SOCKET_F) += socket_F
+subdirs-$(CONFIG_CPU_AMD_SOCKET_AM2) += socket_AM2
diff --git a/src/cpu/amd/microcode/Makefile.inc b/src/cpu/amd/microcode/Makefile.inc
new file mode 100644
index 0000000..26513df
--- /dev/null
+++ b/src/cpu/amd/microcode/Makefile.inc
@@ -0,0 +1 @@
+obj-y += microcode.o
diff --git a/src/cpu/amd/socket_AM2/Kconfig b/src/cpu/amd/socket_AM2/Kconfig
new file mode 100644
index 0000000..d02e79a
--- /dev/null
+++ b/src/cpu/amd/socket_AM2/Kconfig
@@ -0,0 +1,31 @@
+config CPU_AMD_SOCKET_AM2
+	bool
+	default false
+
+config CPU_SOCKET_TYPE
+	hex
+	default 0x10
+	depends on CPU_AMD_SOCKET_AM2
+
+config K8_REV_F_SUPPORT
+	hex
+	default 1
+	depends on CPU_AMD_SOCKET_AM2
+
+#Opteron K8 1G HT Support
+config K8_HT_FREQ_1G_SUPPORT
+	hex
+	default 1
+	depends on CPU_AMD_SOCKET_AM2
+
+#DDR2 and REG
+config DIMM_SUPPORT
+	hex
+	default 0x0104 
+	depends on CPU_AMD_SOCKET_AM2
+
+config CPU_SOCKET_TYPE
+	hex
+	default 0x10
+	depends on CPU_AMD_SOCKET_AM2
+
diff --git a/src/cpu/amd/socket_AM2/Makefile.inc b/src/cpu/amd/socket_AM2/Makefile.inc
new file mode 100644
index 0000000..d90c4c5
--- /dev/null
+++ b/src/cpu/amd/socket_AM2/Makefile.inc
@@ -0,0 +1,16 @@
+obj-y += socket_AM2.o
+subdirs-y += ../model_fxx
+
+subdirs-y += ../dualcore
+subdirs-y += ../mtrr
+subdirs-y += ../microcode
+subdirs-y += ../../x86/tsc
+subdirs-y += ../../x86/mtrr
+subdirs-y += ../../x86/fpu
+subdirs-y += ../../x86/mmx
+subdirs-y += ../../x86/sse
+subdirs-y += ../../x86/lapic
+subdirs-y += ../../x86/cache
+subdirs-y += ../../x86/mtrr
+subdirs-y += ../../x86/pae
+subdirs-y += ../../x86/smm
diff --git a/src/cpu/amd/socket_F/Kconfig b/src/cpu/amd/socket_F/Kconfig
index c933400..30e9080 100644
--- a/src/cpu/amd/socket_F/Kconfig
+++ b/src/cpu/amd/socket_F/Kconfig
@@ -29,4 +29,3 @@ config CPU_SOCKET_TYPE
 	default 0x10
 	depends on CPU_AMD_SOCKET_F
 
-source src/cpu/amd/model_fxx/Kconfig
diff --git a/src/cpu/amd/socket_F/Makefile.inc b/src/cpu/amd/socket_F/Makefile.inc
index bd9885c..a3be24c 100644
--- a/src/cpu/amd/socket_F/Makefile.inc
+++ b/src/cpu/amd/socket_F/Makefile.inc
@@ -1,14 +1,14 @@
-obj-$(CONFIG_CPU_AMD_SOCKET_F) += socket_F.o
-subdirs-$(CONFIG_CPU_AMD_SOCKET_F) += ../model_fxx
-subdirs-$(CONFIG_CPU_AMD_SOCKET_F) += ../dualcore
-subdirs-$(CONFIG_CPU_AMD_SOCKET_F) += ../mtrr
-subdirs-$(CONFIG_CPU_AMD_SOCKET_F) += ../../x86/tsc
-subdirs-$(CONFIG_CPU_AMD_SOCKET_F) += ../../x86/mtrr
-subdirs-$(CONFIG_CPU_AMD_SOCKET_F) += ../../x86/fpu
-subdirs-$(CONFIG_CPU_AMD_SOCKET_F) += ../../x86/mmx
-subdirs-$(CONFIG_CPU_AMD_SOCKET_F) += ../../x86/sse
-subdirs-$(CONFIG_CPU_AMD_SOCKET_F) += ../../x86/lapic
-subdirs-$(CONFIG_CPU_AMD_SOCKET_F) += ../../x86/cache
-subdirs-$(CONFIG_CPU_AMD_SOCKET_F) += ../../x86/mtrr
-subdirs-$(CONFIG_CPU_AMD_SOCKET_F) += ../../x86/pae
-subdirs-$(CONFIG_CPU_AMD_SOCKET_F) += ../../x86/smm
+obj-y += socket_F.o
+subdirs-y += ../model_fxx
+subdirs-y += ../dualcore
+subdirs-y += ../mtrr
+subdirs-y += ../../x86/tsc
+subdirs-y += ../../x86/mtrr
+subdirs-y += ../../x86/fpu
+subdirs-y += ../../x86/mmx
+subdirs-y += ../../x86/sse
+subdirs-y += ../../x86/lapic
+subdirs-y += ../../x86/cache
+subdirs-y += ../../x86/mtrr
+subdirs-y += ../../x86/pae
+subdirs-y += ../../x86/smm