Index: src/cpu/amd/Kconfig
===================================================================
--- src/cpu/amd/Kconfig	(revision 4565)
+++ src/cpu/amd/Kconfig	(working copy)
@@ -1,6 +1,6 @@
 #source src/cpu/amd/socket_754/Kconfig
 #source src/cpu/amd/socket_939/Kconfig
-#source src/cpu/amd/socket_940/Kconfig
+source src/cpu/amd/socket_940/Kconfig
 source src/cpu/amd/socket_AM2/Kconfig
 #source src/cpu/amd/socket_AM2r2/Kconfig
 source src/cpu/amd/socket_F/Kconfig
Index: src/cpu/amd/socket_940/Kconfig
===================================================================
--- src/cpu/amd/socket_940/Kconfig	(revision 4558)
+++ src/cpu/amd/socket_940/Kconfig	(working copy)
@@ -1,32 +1,14 @@
-config CPU_AMD_SOCKET_F
+config CPU_AMD_SOCKET_940
 	bool
 	default false
 
-config CPU_SOCKET_TYPE
-	hex
-	default 0x10
-	depends on CPU_AMD_SOCKET_F
-
 config K8_REV_F_SUPPORT
 	hex
-	default 1
-	depends on CPU_AMD_SOCKET_F
+	default 0
+	depends on CPU_AMD_SOCKET_940
 
 #Opteron K8 1G HT Support
 config K8_HT_FREQ_1G_SUPPORT
 	hex
 	default 1
-	depends on CPU_AMD_SOCKET_F
-
-#DDR2 and REG
-config DIMM_SUPPORT
-	hex
-	default 0x0104 
-	depends on CPU_AMD_SOCKET_F
-
-config CPU_SOCKET_TYPE
-	hex
-	default 0x10
-	depends on CPU_AMD_SOCKET_F
-
-source src/cpu/amd/model_fxx/Kconfig
+	depends on CPU_AMD_SOCKET_940

Property changes on: src/cpu/amd/socket_940/Kconfig
___________________________________________________________________
Added: svn:mergeinfo

Index: src/cpu/amd/socket_940/Makefile.inc
===================================================================
--- src/cpu/amd/socket_940/Makefile.inc	(revision 4564)
+++ src/cpu/amd/socket_940/Makefile.inc	(working copy)
@@ -1,14 +1,2 @@
-obj-y += socket_F.o
+obj-y += socket_940.o
 subdirs-y += ../model_fxx
-subdirs-y += ../dualcore
-subdirs-y += ../mtrr
-subdirs-y += ../../x86/tsc
-subdirs-y += ../../x86/mtrr
-subdirs-y += ../../x86/fpu
-subdirs-y += ../../x86/mmx
-subdirs-y += ../../x86/sse
-subdirs-y += ../../x86/lapic
-subdirs-y += ../../x86/cache
-subdirs-y += ../../x86/mtrr
-subdirs-y += ../../x86/pae
-subdirs-y += ../../x86/smm

Property changes on: src/cpu/amd/socket_940/Makefile.inc
___________________________________________________________________
Added: svn:mergeinfo

Index: src/cpu/amd/Makefile.inc
===================================================================
--- src/cpu/amd/Makefile.inc	(revision 4565)
+++ src/cpu/amd/Makefile.inc	(working copy)
@@ -1,2 +1,3 @@
 subdirs-$(CONFIG_CPU_AMD_SOCKET_F) += socket_F
+subdirs-$(CONFIG_CPU_AMD_SOCKET_940) += socket_940
 subdirs-$(CONFIG_CPU_AMD_SOCKET_AM2) += socket_AM2
Index: src/cpu/amd/model_fxx/Makefile.inc
===================================================================
--- src/cpu/amd/model_fxx/Makefile.inc	(revision 4564)
+++ src/cpu/amd/model_fxx/Makefile.inc	(working copy)
@@ -4,3 +4,16 @@
 obj-y += model_fxx_update_microcode.o
 obj-y += processor_name.o
 obj-y += powernow_acpi.o
+subdirs-y += ../dualcore
+subdirs-y += ../mtrr
+subdirs-y += ../microcode
+subdirs-y += ../../x86/tsc
+subdirs-y += ../../x86/mtrr
+subdirs-y += ../../x86/fpu
+subdirs-y += ../../x86/mmx
+subdirs-y += ../../x86/sse
+subdirs-y += ../../x86/lapic
+subdirs-y += ../../x86/cache
+subdirs-y += ../../x86/mtrr
+subdirs-y += ../../x86/pae
+subdirs-y += ../../x86/smm
Index: src/cpu/amd/socket_AM2/Makefile.inc
===================================================================
--- src/cpu/amd/socket_AM2/Makefile.inc	(revision 4565)
+++ src/cpu/amd/socket_AM2/Makefile.inc	(working copy)
@@ -1,15 +1,2 @@
 obj-y += socket_AM2.o
 subdirs-y += ../model_fxx
-subdirs-y += ../dualcore
-subdirs-y += ../mtrr
-subdirs-y += ../microcode
-subdirs-y += ../../x86/tsc
-subdirs-y += ../../x86/mtrr
-subdirs-y += ../../x86/fpu
-subdirs-y += ../../x86/mmx
-subdirs-y += ../../x86/sse
-subdirs-y += ../../x86/lapic
-subdirs-y += ../../x86/cache
-subdirs-y += ../../x86/mtrr
-subdirs-y += ../../x86/pae
-subdirs-y += ../../x86/smm
Index: src/cpu/amd/socket_F/Makefile.inc
===================================================================
--- src/cpu/amd/socket_F/Makefile.inc	(revision 4564)
+++ src/cpu/amd/socket_F/Makefile.inc	(working copy)
@@ -1,14 +1,2 @@
 obj-y += socket_F.o
 subdirs-y += ../model_fxx
-subdirs-y += ../dualcore
-subdirs-y += ../mtrr
-subdirs-y += ../../x86/tsc
-subdirs-y += ../../x86/mtrr
-subdirs-y += ../../x86/fpu
-subdirs-y += ../../x86/mmx
-subdirs-y += ../../x86/sse
-subdirs-y += ../../x86/lapic
-subdirs-y += ../../x86/cache
-subdirs-y += ../../x86/mtrr
-subdirs-y += ../../x86/pae
-subdirs-y += ../../x86/smm