Index: src/devices/Kconfig
===================================================================
--- src/devices/Kconfig	(revision 4582)
+++ src/devices/Kconfig	(working copy)
@@ -21,33 +21,35 @@
 menu "Devices"
 
 config VGA_ROM_RUN
-	bool
+	bool "Run VGA Option ROMs"
 	help
-	  Execute PCI/AGP option ROMs if available. This is required to
-	  enable PCI/AGP VGA plugin cards.
+	  Execute VGA option ROMs if found. This is required to enable PCI/AGP
+	  VGA plugin cards. 
 
-choice
-	prompt "Execute PCI option ROMs"
-	default PCI_OPTION_ROM_RUN_REALMODE
+config PCI_ROM_RUN
+	bool "Run non-VGA Option ROMs"
 	help
-	  Execute PCI/AGP option ROMs if available. You can choose to
-	  execute PCI option ROMs natively (32bit x86 system required),
-	  in an emulator (x86emu), or ignore option ROM execution.
+	  Execute non-VGA PCI option ROMs if found.
 
-config PCI_OPTION_ROM_RUN_REALMODE
-	prompt "Run VGA ROMs"
-	bool
-	select VGA_ROM_RUN
-	help
-	  Execute PCI/AGP option ROMs if available. This is required to
-	  enable PCI/AGP VGA plugin cards.
+choice
+        prompt "Option ROM Execution"
+        default  PCI_OPTION_ROM_RUN_REALMODE
+	depends on PCI_ROM_RUN || VGA_ROM_RUN
+        help
+          You can choose to execute PCI option ROMs natively (32bit x86 system
+	  required) or in an emulator (x86emu or YABEL).
 
-config NO_RUN
-	prompt "Do NOT run VGA ROMs"
-	bool
-	help
-	  Do not execute PCI/AGP option ROMs.
+	config PCI_OPTION_ROM_RUN_REALMODE
+		prompt "Real mode"
+		bool
 
+	config PCI_OPTION_ROM_RUN_YABEL
+		prompt "YABEL"
+		bool
+
+	config PCI_OPTION_ROM_RUN_X86EMU
+		prompt "X86EMU"
+		bool
 endchoice
 
 endmenu
Index: src/devices/Makefile.inc
===================================================================
--- src/devices/Makefile.inc	(revision 4582)
+++ src/devices/Makefile.inc	(working copy)
@@ -12,8 +12,8 @@
 obj-y += smbus_ops.o
 
 ifeq ($(CONFIG_PCI_ROM_RUN),y)
-obj-$(CONFIG_PCI_ROM_RUN) += pci_rom.o
-subdirs-$(CONFIG_PCI_ROM_RUN) += ../../util/x86emu
+obj-y += pci_rom.o
+subdirs-y += ../../util/x86emu
 else
 obj-$(CONFIG_VGA_ROM_RUN) += pci_rom.o
 subdirs-$(CONFIG_VGA_ROM_RUN) += ../../util/x86emu
Index: util/x86emu/Makefile.inc
===================================================================
--- util/x86emu/Makefile.inc	(revision 4582)
+++ util/x86emu/Makefile.inc	(working copy)
@@ -19,9 +19,12 @@
 ##
 
 subdirs-$(CONFIG_PCI_OPTION_ROM_RUN_X86EMU) += x86emu
-obj-$(CONFIG_PCI_OPTION_ROM_RUN_X86EMU) += biosemu.c
+obj-$(CONFIG_PCI_OPTION_ROM_RUN_X86EMU) += biosemu.o
 subdirs-$(CONFIG_PCI_OPTION_ROM_RUN_X86EMU) += pcbios
 
 obj-$(CONFIG_PCI_OPTION_ROM_RUN_REALMODE) += x86.o
 obj-$(CONFIG_PCI_OPTION_ROM_RUN_REALMODE) += x86_asm.o
 obj-$(CONFIG_PCI_OPTION_ROM_RUN_REALMODE) += x86_interrupts.o
+
+subdirs-$(CONFIG_PCI_OPTION_ROM_RUN_YABEL) += x86emu
+subdirs-$(CONFIG_PCI_OPTION_ROM_RUN_YABEL) += yabel
Index: util/x86emu/yabel/compat/Makefile.inc
===================================================================
--- util/x86emu/yabel/compat/Makefile.inc	(revision 0)
+++ util/x86emu/yabel/compat/Makefile.inc	(revision 0)
@@ -0,0 +1 @@
+obj-y += functions.o
Index: util/x86emu/yabel/Makefile.inc
===================================================================
--- util/x86emu/yabel/Makefile.inc	(revision 0)
+++ util/x86emu/yabel/Makefile.inc	(revision 0)
@@ -0,0 +1,8 @@
+obj-y += biosemu.o
+obj-y += debug.o
+obj-y += device.o
+obj-y += interrupt.o
+obj-y += io.o
+obj-y += mem.o
+obj-y += pmm.o
+subdirs-y += compat
Index: src/mainboard/amd/serengeti_cheetah/Kconfig
===================================================================
--- src/mainboard/amd/serengeti_cheetah/Kconfig	(revision 4582)
+++ src/mainboard/amd/serengeti_cheetah/Kconfig	(working copy)
@@ -188,8 +188,3 @@
 	default y
 	depends on BOARD_AMD_SERENGETI_CHEETAH
 
-config PCI_ROM_RUN
-	bool
-	default y
-	depends on BOARD_AMD_SERENGETI_CHEETAH
-
Index: src/Kconfig
===================================================================
--- src/Kconfig	(revision 4582)
+++ src/Kconfig	(working copy)
@@ -84,10 +84,6 @@
 	int
 	default 1
 
-config PCI_ROM_RUN
-	bool
-	default n
-
 config HT_CHAIN_UNITID_BASE
 	int
 	default 1