From 1c9f74e0a45282cb92163c6f7596829f6732bb5c Mon Sep 17 00:00:00 2001
From: =?utf-8?q?Cristi=20M=C4=83gheru=C8=99an?= <cristi.magherusan@net.utcluj.ro>
Date: Wed, 26 Aug 2009 18:09:43 +0300
Subject: [PATCH] added Asus M2V-MX_SE to Kbuild

---
 src/mainboard/asus/Kconfig                |    1 +
 src/mainboard/asus/m2v-mx_se/Kconfig      |  130 +++++++++++++++++++++++++++++
 src/mainboard/asus/m2v-mx_se/Makefile.inc |   65 ++++++++++++++
 3 files changed, 196 insertions(+), 0 deletions(-)
 create mode 100644 src/mainboard/asus/m2v-mx_se/Kconfig
 create mode 100644 src/mainboard/asus/m2v-mx_se/Makefile.inc

diff --git a/src/mainboard/asus/Kconfig b/src/mainboard/asus/Kconfig
index 902cb37..7069f8a 100644
--- a/src/mainboard/asus/Kconfig
+++ b/src/mainboard/asus/Kconfig
@@ -23,6 +23,7 @@ choice
 	depends on VENDOR_ASUS
 	
 source "src/mainboard/asus/p2b-f/Kconfig"
+source "src/mainboard/asus/m2v-mx_se/Kconfig"
 
 endchoice
 
diff --git a/src/mainboard/asus/m2v-mx_se/Kconfig b/src/mainboard/asus/m2v-mx_se/Kconfig
new file mode 100644
index 0000000..c785fd8
--- /dev/null
+++ b/src/mainboard/asus/m2v-mx_se/Kconfig
@@ -0,0 +1,125 @@
+##
+## This file is part of the coreboot project.
+##
+## Copyright (C) 2009 Cristi Măgherușan <cristi.magherusan@net.utcluj.ro>
+##
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
+##
+
+config BOARD_ASUS_M2V_MX_SE
+	bool "M2V-MX-SE"
+	select ARCH_X86
+	select CPU_AMD_K8
+	select CPU_AMD_SOCKET_AM2
+	select NORTHBRIDGE_AMD_AMDK8
+	select NORTHBRIDGE_AMD_AMDK8_ROOT_COMPLEX
+	select SOUTHBRIDGE_VIA_VT8237R
+	select SOUTHBRIDGE_VIA_K8T890
+	select SUPERIO_ITE_IT8712F
+	select USE_PRINTK_IN_CAR
+	help
+	  Asus M2V-MX-SE mainboard.
+
+config MAINBOARD_DIR
+	string
+	default asus/m2v-mx_se
+	depends on BOARD_ASUS_M2V_MX_SE
+
+config USE_DCACHE_RAM
+	bool
+	dafault y
+	depends on BOARD_ASUS_M2V_MX_SE
+	
+config DCACHE_RAM_BASE
+	hex
+	default 0xcc000
+	depends on BOARD_ASUS_M2V_MX_SE
+	
+config DCACHE_RAM_SIZE
+	hex
+	default 0x4000
+	depends on BOARD_ASUS_M2V_MX_SE
+
+config DCACHE_RAM_GLOBAL_VAR_SIZE
+	hex
+	default 0x01000
+	depends on BOARD_ASUS_M2V_MX_SE
+
+config APIC_ID_OFFSET
+	hex
+	default 0x10
+	depends on BOARD_ASUS_M2V_MX_SE
+
+config HAVE_HARD_RESET
+	bool
+	default y
+	depends on BOARD_ASUS_M2V_MX_SE
+
+config IOAPIC
+	bool
+	default y
+	depends on BOARD_ASUS_M2V_MX_SE
+
+config MAINBOARD_VENDOR
+	string
+	default "ASUS"
+	depends on BOARD_ASUS_M2V_MX_SE
+
+config MAINBOARD_PART_NUMBER
+	string
+	default "M2V-MX SE"
+	depends on BOARD_ASUS_M2V_MX_SE
+
+config MAX_CPUS
+	int
+	default 2
+	depends on BOARD_ASUS_M2V_MX_SE
+
+config MAX_PHYSICAL_CPUS
+	int
+	default 1
+	depends on BOARD_ASUS_M2V_MX_SE
+
+config STACK_SIZE
+	int
+	default 8192
+	depends on BOARD_ASUS_M2V_MX_SE
+
+config HEAP_SIZE
+	int
+	default 262144
+	depends on BOARD_ASUS_M2V_MX_SE
+
+config HAVE_OPTION_TABLE
+	bool
+	default y
+	depends on BOARD_ASUS_M2V_MX_SE
+
+config HAVE_ACPI_TABLES
+	bool
+	default y
+	depends on BOARD_ASUS_M2V_MX_SE
+
+
+config LB_CKS_RANGE_END
+	int
+	default 122
+	depends on BOARD_ASUS_M2V_MX_SE
+
+config LB_CKS_LOC
+	int
+	default	123
+	depends	on BOARD_ASUS_M2V_MX_SE
+
diff --git a/src/mainboard/asus/m2v-mx_se/Makefile.inc b/src/mainboard/asus/m2v-mx_se/Makefile.inc
new file mode 100644
index 0000000..eee35eb
--- /dev/null
+++ b/src/mainboard/asus/m2v-mx_se/Makefile.inc
@@ -0,0 +1,65 @@
+##
+## This file is part of the coreboot project.
+## 
+## Copyright (C) 2007-2008 coresystems GmbH
+## Copyright (C) 2009 Cristi Măgherușan <cristi.magherusan@net.utcluj.ro>
+##
+## This program is free software; you can redistribute it and/or
+## modify it under the terms of the GNU General Public License as
+## published by the Free Software Foundation; version 2 of
+## the License.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
+## MA 02110-1301 USA
+##
+
+driver-y +=  mainboard.o
+
+#needed by irq_tables and mptable and acpi_tables
+obj-$(CONFIG_HAVE_ACPI_TABLES) +=  dsdt.o
+obj-$(CONFIG_HAVE_ACPI_TABLES) +=  acpi_tables.o
+
+# This is part of the conversion to init-obj and away from included code. 
+
+initobj-y += crt0.o
+# FIXME in $(top)/Makefile
+crt0-y += ../../../../src/cpu/x86/16bit/entry16.inc
+crt0-y += ../../../../src/cpu/x86/32bit/entry32.inc
+crt0-y += ../../../../src/cpu/x86/16bit/reset16.inc
+crt0-y += ../../../../src/arch/i386/lib/id.inc
+crt0-y += ../../../../src/cpu/amd/car/cache_as_ram.inc
+crt0-y += auto.inc
+
+ldscript-y += ../../../../src/arch/i386/init/ldscript_fallback_cbfs.lb
+ldscript-y += ../../../../src/cpu/x86/16bit/entry16.lds
+ldscript-y += ../../../../src/cpu/x86/16bit/reset16.lds
+ldscript-y += ../../../../src/arch/i386/lib/id.lds
+ldscript-y += ../../../../src/arch/i386/lib/failover.lds
+
+ifdef POST_EVALUATION
+
+MAINBOARD_OPTIONS=\
+	-DCONFIG_AP_IN_SIPI_WAIT=0 \
+	-DCONFIG_USE_PRINTK_IN_CAR=1 
+
+$(obj)/dsdt.c: $(src)/mainboard/$(MAINBOARDDIR)/dsdt.asl
+	iasl -p dsdt -tc $(src)/mainboard/$(MAINBOARDDIR)/dsdt.asl
+	mv dsdt.hex $@
+
+$(obj)/mainboard/$(MAINBOARDDIR)/dsdt.o: $(obj)/dsdt.c
+	$(CC) $(DISTRO_CFLAGS) $(CFLAGS) $(CPPFLAGS) $(DEBUG_CFLAGS) -I$(src) -I. -c $< -o $@
+
+$(obj)/mainboard/$(MAINBOARDDIR)/auto.inc: $(src)/mainboard/$(MAINBOARDDIR)/cache_as_ram_auto.c $(obj)/option_table.h
+	$(CC) $(DISTRO_CFLAGS) $(CFLAGS) $(CPPFLAGS) $(DEBUG_CFLAGS) -I$(src) -I. -c -S  $(src)/mainboard/$(MAINBOARDDIR)/cache_as_ram_auto.c -o $@
+	perl -e 's/\.rodata/.rom.data/g' -pi $@
+	perl -e 's/\.text/.section .rom.text/g' -pi $@
+
+endif
+
-- 
1.6.0.4