From e727c487fced8908867bdf02200cebbbf798c041 Mon Sep 17 00:00:00 2001
From: =?utf-8?q?Cristi=20M=C4=83gheru=C8=99an?= <cristi.magherusan@net.utcluj.ro>
Date: Thu, 27 Aug 2009 17:03:03 +0300
Subject: [PATCH] added support for AMD sb600 and rs690 southbridges in Kconfig

---
 src/southbridge/amd/Kconfig            |    4 ++--
 src/southbridge/amd/rs690/Kconfig      |   23 +++++++++++++++++++++++
 src/southbridge/amd/rs690/Makefile.inc |    5 +++++
 src/southbridge/amd/sb600/Kconfig      |   23 +++++++++++++++++++++++
 src/southbridge/amd/sb600/Makefile.inc |   10 ++++++++++
 5 files changed, 63 insertions(+), 2 deletions(-)
 create mode 100644 src/southbridge/amd/rs690/Kconfig
 create mode 100644 src/southbridge/amd/rs690/Makefile.inc
 create mode 100644 src/southbridge/amd/sb600/Kconfig
 create mode 100644 src/southbridge/amd/sb600/Makefile.inc

diff --git a/src/southbridge/amd/Kconfig b/src/southbridge/amd/Kconfig
index e8edbf4..9ed63fe 100644
--- a/src/southbridge/amd/Kconfig
+++ b/src/southbridge/amd/Kconfig
@@ -6,5 +6,5 @@ source src/southbridge/amd/amd8131/Kconfig
 #source src/southbridge/amd/cs5530/Kconfig
 #source src/southbridge/amd/cs5535/Kconfig
 #source src/southbridge/amd/cs5536/Kconfig
-#source src/southbridge/amd/rs690/Kconfig
-#source src/southbridge/amd/sb600/Kconfig
+source src/southbridge/amd/rs690/Kconfig
+source src/southbridge/amd/sb600/Kconfig
diff --git a/src/southbridge/amd/rs690/Kconfig b/src/southbridge/amd/rs690/Kconfig
new file mode 100644
index 0000000..7b6e34e
--- /dev/null
+++ b/src/southbridge/amd/rs690/Kconfig
@@ -0,0 +1,23 @@
+##
+## This file is part of the coreboot project.
+##
+## Copyright (C) 2008-2009 coresystems GmbH
+##
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; version 2 of the License.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
+##
+
+config SOUTHBRIDGE_AMD_RS690
+	bool
+	default n
+
diff --git a/src/southbridge/amd/rs690/Makefile.inc b/src/southbridge/amd/rs690/Makefile.inc
new file mode 100644
index 0000000..875c028
--- /dev/null
+++ b/src/southbridge/amd/rs690/Makefile.inc
@@ -0,0 +1,5 @@
+driver-y += rs690.o
+driver-y += rs690_cmn.o
+driver-y += rs690_pcie.o
+driver-y += rs690_ht.o
+driver-y += rs690_gfx.o
diff --git a/src/southbridge/amd/sb600/Kconfig b/src/southbridge/amd/sb600/Kconfig
new file mode 100644
index 0000000..8888927
--- /dev/null
+++ b/src/southbridge/amd/sb600/Kconfig
@@ -0,0 +1,23 @@
+##
+## This file is part of the coreboot project.
+##
+## Copyright (C) 2008-2009 coresystems GmbH
+##
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; version 2 of the License.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
+##
+
+config SOUTHBRIDGE_AMD_SB600
+	bool
+	default n
+
diff --git a/src/southbridge/amd/sb600/Makefile.inc b/src/southbridge/amd/sb600/Makefile.inc
new file mode 100644
index 0000000..17e9263
--- /dev/null
+++ b/src/southbridge/amd/sb600/Makefile.inc
@@ -0,0 +1,10 @@
+driver-y += sb600.o
+driver-y += sb600_usb.o
+driver-y += sb600_lpc.o
+driver-y += sb600_sm.o
+driver-y += sb600_ide.o
+driver-y += sb600_sata.o
+driver-y += sb600_hda.o
+driver-y += sb600_ac97.o
+driver-y += sb600_pci.o
+obj-y += sb600_reset.o
-- 
1.6.0.4