Index: src/cpu/amd/socket_S1G1/Kconfig
===================================================================
--- src/cpu/amd/socket_S1G1/Kconfig	(Revision 4683)
+++ src/cpu/amd/socket_S1G1/Kconfig	(Arbeitskopie)
@@ -1,22 +1,14 @@
 config CPU_AMD_SOCKET_S1G1
         bool
-	default false
+	default n
+	select K8_REV_F_SUPPORT
+	select K8_HT_FREQ_1G_SUPPORT
 
-config K8_REV_F_SUPPORT
-	bool
-	default true
-	depends on CPU_AMD_SOCKET_S1G1
-
 config CPU_SOCKET_TYPE
 	hex
 	default 0x12
 	depends on CPU_AMD_SOCKET_S1G1
 
-config K8_HT_FREQ_1G_SUPPORT
-	bool
-	default y
-	depends on CPU_AMD_SOCKET_S1G1
-
 #DDR2 and REG, S1G1
 config DIMM_SUPPORT
 	hex
Index: src/cpu/amd/socket_940/Kconfig
===================================================================
--- src/cpu/amd/socket_940/Kconfig	(Revision 4683)
+++ src/cpu/amd/socket_940/Kconfig	(Arbeitskopie)
@@ -1,19 +1,11 @@
 config CPU_AMD_SOCKET_940
 	bool
-	default false
+	default n
+	#Opteron K8 1G HT Support
+	select K8_HT_FREQ_1G_SUPPORT
+	select CPU_AMD_MODEL_FXX
 
 config K8_REV_F_SUPPORT
 	bool
 	default n
 	depends on CPU_AMD_SOCKET_940
-
-#Opteron K8 1G HT Support
-config K8_HT_FREQ_1G_SUPPORT
-	bool
-	default y
-	depends on CPU_AMD_SOCKET_940
-
-config CPU_AMD_MODEL_FXX
-	bool
-	default y
-	depends on CPU_AMD_SOCKET_940
Index: src/cpu/amd/socket_AM2/Kconfig
===================================================================
--- src/cpu/amd/socket_AM2/Kconfig	(Revision 4683)
+++ src/cpu/amd/socket_AM2/Kconfig	(Arbeitskopie)
@@ -1,23 +1,15 @@
 config CPU_AMD_SOCKET_AM2
 	bool
-	default false
+	default n
+	select K8_REV_F_SUPPORT
+	# Opteron K8 1G HT support
+	select K8_HT_FREQ_1G_SUPPORT
 
 config CPU_SOCKET_TYPE
 	hex
 	default 0x11
 	depends on CPU_AMD_SOCKET_AM2
 
-config K8_REV_F_SUPPORT
-	bool
-	default y
-	depends on CPU_AMD_SOCKET_AM2
-
-# Opteron K8 1G HT support
-config K8_HT_FREQ_1G_SUPPORT
-	bool
-	default y
-	depends on CPU_AMD_SOCKET_AM2
-
 # DDR2 and REG
 config DIMM_SUPPORT
 	hex
Index: src/cpu/amd/socket_F/Kconfig
===================================================================
--- src/cpu/amd/socket_F/Kconfig	(Revision 4683)
+++ src/cpu/amd/socket_F/Kconfig	(Arbeitskopie)
@@ -1,23 +1,15 @@
 config CPU_AMD_SOCKET_F
 	bool
-	default false
+	default n
+	select K8_REV_F_SUPPORT
+	# Opteron K8 1G HT support
+	select K8_HT_FREQ_1G_SUPPORT
 
 config CPU_SOCKET_TYPE
 	hex
 	default 0x10
 	depends on CPU_AMD_SOCKET_F
 
-config K8_REV_F_SUPPORT
-	bool
-	default y
-	depends on CPU_AMD_SOCKET_F
-
-# Opteron K8 1G HT support
-config K8_HT_FREQ_1G_SUPPORT
-	bool
-	default y
-	depends on CPU_AMD_SOCKET_F
-
 # DDR2 and REG
 config DIMM_SUPPORT
 	hex
Index: src/cpu/intel/ep80579/Kconfig
===================================================================
--- src/cpu/intel/ep80579/Kconfig	(Revision 4683)
+++ src/cpu/intel/ep80579/Kconfig	(Arbeitskopie)
@@ -1,3 +1,3 @@
 config CPU_INTEL_EP80579
 	bool
-	default false
+	default n
Index: src/cpu/intel/socket_mPGA603/Kconfig
===================================================================
--- src/cpu/intel/socket_mPGA603/Kconfig	(Revision 4683)
+++ src/cpu/intel/socket_mPGA603/Kconfig	(Arbeitskopie)
@@ -1,6 +1,6 @@
 config CPU_INTEL_SOCKET_MPGA603
 	bool
-	default false
+	default n
 	select CPU_INTEL_MODEL_F0X
 	select CPU_INTEL_MODEL_F1X
 	select CPU_INTEL_MODEL_F2X
Index: src/cpu/intel/socket_mPGA604/Kconfig
===================================================================
--- src/cpu/intel/socket_mPGA604/Kconfig	(Revision 4683)
+++ src/cpu/intel/socket_mPGA604/Kconfig	(Arbeitskopie)
@@ -1,6 +1,6 @@
 config CPU_INTEL_SOCKET_MPGA604
 	bool
-	default false
+	default n
 	select CPU_INTEL_MODEL_F2X
 	select CPU_INTEL_MODEL_F3X
 	select CPU_INTEL_MODEL_F4X
Index: src/cpu/intel/socket_mPGA478/Kconfig
===================================================================
--- src/cpu/intel/socket_mPGA478/Kconfig	(Revision 4683)
+++ src/cpu/intel/socket_mPGA478/Kconfig	(Arbeitskopie)
@@ -1,5 +1,5 @@
 config CPU_INTEL_SOCKET_MPGA478
 	bool
-	default false
+	default n
 	select CPU_INTEL_MODEL_69X
 	select CPU_INTEL_MODEL_6DX
Index: src/cpu/intel/socket_mFCPGA478/Kconfig
===================================================================
--- src/cpu/intel/socket_mFCPGA478/Kconfig	(Revision 4683)
+++ src/cpu/intel/socket_mFCPGA478/Kconfig	(Arbeitskopie)
@@ -1,3 +1,3 @@
 config CPU_INTEL_SOCKET_MFCPGA478
 	bool
-	default false
+	default n
Index: src/cpu/intel/socket_PGA370/Kconfig
===================================================================
--- src/cpu/intel/socket_PGA370/Kconfig	(Revision 4683)
+++ src/cpu/intel/socket_PGA370/Kconfig	(Arbeitskopie)
@@ -20,4 +20,4 @@
 
 config CPU_INTEL_SOCKET_PGA370
 	bool
-	default false
+	default n
Index: src/cpu/intel/socket_mPGA479M/Kconfig
===================================================================
--- src/cpu/intel/socket_mPGA479M/Kconfig	(Revision 4683)
+++ src/cpu/intel/socket_mPGA479M/Kconfig	(Arbeitskopie)
@@ -1,5 +1,5 @@
 config CPU_INTEL_SOCKET_MPGA479M
 	bool
-	default false
+	default n
 	select CPU_INTEL_MODEL_69X
 	select CPU_INTEL_MODEL_6DX
Index: src/cpu/emulation/qemu-x86/Kconfig
===================================================================
--- src/cpu/emulation/qemu-x86/Kconfig	(Revision 4683)
+++ src/cpu/emulation/qemu-x86/Kconfig	(Arbeitskopie)
@@ -1,4 +1,4 @@
 config CPU_EMULATION_QEMU_X86
 	bool
-	default false
+	default n
 
Index: src/mainboard/intel/xe7501devkit/Makefile.inc
===================================================================
--- src/mainboard/intel/xe7501devkit/Makefile.inc	(Revision 4683)
+++ src/mainboard/intel/xe7501devkit/Makefile.inc	(Arbeitskopie)
@@ -1,7 +1,7 @@
 ROMCCFLAGS := -mcpu=p4
 obj-$(CONFIG_HAVE_ACPI_TABLES) += acpi_tables.o
 ifeq ($(CONFIG_PCI_ROM_RUN),y)
-	ifeq ($(CONFIG_PCI_ROM_RUN),y)
+	ifeq ($(CONFIG_CONSOLE_VGA),y)
 		obj-y += vgarom.o
 	else
 		obj-y += no_vgarom.o
Index: src/northbridge/intel/i440bx/Kconfig
===================================================================
--- src/northbridge/intel/i440bx/Kconfig	(Revision 4683)
+++ src/northbridge/intel/i440bx/Kconfig	(Arbeitskopie)
@@ -25,4 +25,5 @@
 config HAVE_HIGH_TABLES
 	bool
 	default y
+	depends on NORTHBRIDGE_INTEL_I440BX
 